function imgOut = inpaintingRGB (immagine,BW)

[Height,Width,Depth] = size(immagine);

imgOut = zeros(size(immagine));

if Depth ~= 3
    return;
end

clear Depth Height Width;

%% --------------- Suddivisione nei 3 canali --------------- 

%Red component
imgR = immagine(:,:,1);

%Green Component
imgG = immagine(:,:,2);

%Blue component
imgB = immagine(:,:,3);


%% --------------- Inpaintint dei 3 canali --------------- 

imgR_inp = inpaintingBN(imgR,BW);

imgG_inp = inpaintingBN(imgG,BW);

imgB_inp = inpaintingBN(imgB,BW);


%% --------------- Ricostruzione --------------- 

imgOut(:,:,1) = imgR_inp;

imgOut(:,:,2) = imgG_inp;

imgOut(:,:,3) = imgB_inp;


imgOut = uint8(imgOut);







