clc; close all; clear all; 

% -- Load --
img = imread('./images/shapes.jpg');  %lena_gray image_new.jpg shark

[Height,Width,Depth] = size(img);

img = rgb2gray(img);
% immagine = histeq(rgb2gray(immagine));
%immagine = imresize(immagine,1/4);  

h0=[sqrt(2)/2 sqrt(2)/2];
h1=[sqrt(2)/2 -sqrt(2)/2];
g0=[sqrt(2)/2 sqrt(2)/2];
g1=[-sqrt(2)/2 sqrt(2)/2];

[cA_u_1,cH_u_1,cV_u_1,cD_u_1] = dwt2(img,h0,h1);      %computes the approximation coefficients matrix cA and details coefficients matrices cH, cV, and cD (horizontal, vertical, and diagonal, respectively)
[cA_u_2,cH_u_2,cV_u_2,cD_u_2] = dwt2(cA_u_1,h0,h1);
[cA_u_3,cH_u_3,cV_u_3,cD_u_3] = dwt2(cA_u_2,h0,h1);

cA_u_3_vis = rescale_0_255(cA_u_3);
cH_u_3_vis = rescale_0_255(cH_u_3);
cV_u_3_vis = rescale_0_255(cV_u_3);
cD_u_3_vis = rescale_0_255(cD_u_3);

c_u_3_vis = [cA_u_3_vis cH_u_3_vis ;
        cV_u_3_vis cD_u_3_vis];
    
cH_u_2_vis = rescale_0_255(cH_u_2);
cV_u_2_vis = rescale_0_255(cV_u_2);
cD_u_2_vis = rescale_0_255(cD_u_2);

c_u_2_vis = [c_u_3_vis cH_u_2_vis;
      cV_u_2_vis cD_u_2_vis];

cH_u_1_vis = rescale_0_255(cH_u_1);
cV_u_1_vis = rescale_0_255(cV_u_1);
cD_u_1_vis = rescale_0_255(cD_u_1);

c_u_vis = [c_u_2_vis cH_u_1_vis ; 
      cV_u_1_vis cD_u_1_vis]; 
  
c_u_vis = uint8(c_u_vis);


c_u_vis(Height/2:Height/2+1,:)=0;
c_u_vis(:,Width/2:Width/2+1)=0;
c_u_vis(Height/4:Height/4+1,1:Width/2)=0;
c_u_vis(1:Height/2,Width/4:Width/4+1)=0;
c_u_vis(Height/8:Height/8+1,1:Width/4)=0;
c_u_vis(1:Height/4,Width/8:Width/8+1)=0;


figure;imshow((c_u_vis));   