clc; close all; clear all; 

% -- Load --
immagine = imread('./images/aereo.jpg');  %lena_gray image_new.jpg shark

%immagine = rgb2gray(immagine);
% immagine = histeq(rgb2gray(immagine));
immagine = imresize(immagine,1/4);  

% -- Selezione della maschera --
BW = roipoly(immagine);

% -- Inpainting --
[Height,Width,Depth] = size(immagine);

if (Depth == 3)
    img(:,:,1) = immagine(:,:,1).*uint8(~BW);
    img(:,:,2) = immagine(:,:,2).*uint8(~BW);
    img(:,:,3) = immagine(:,:,3).*uint8(~BW);
    imgOut = inpaintingRGB(img,BW);         

    figure;imshow(imgOut);

elseif (Depth == 1)
    
    % -- Inpainting --
    img = immagine.*uint8(~BW);
	imgOut_3_livelli = inpaintingBN(img,BW);
%     imgOut_2_livelli = inpaintingBN_2_livelli(img,BW);
%     imgOut_1_livelli = inpaintingBN_1_livelli(img,BW);
% 	[imgOut_onlyCoarse,alto_sx,alto_dx,basso_dx,basso_sx] = LinPredCoarse(img,BW);              % Semplice predizione, senza Wavelet e Multirisoluzione
%     imgOut_onlyCoarse = uint8(imgOut_onlyCoarse);
  
    % -- Risultati --
%     psnr_3_livelli = psnr(immagine,imgOut_3_livelli,BW);
%     psnr_2_livelli = psnr(immagine,imgOut_2_livelli,BW);
%     psnr_1_livelli = psnr(immagine,imgOut_1_livelli,BW);
%    psnr_onlyCoarse = psnr(immagine,imgOut_onlyCoarse,BW);

    % -- Visualizzazioni --
     figure, set(gcf,'name','3 Livelli'); imshow(imgOut_3_livelli);
%    figure, set(gcf,'name','imgOut_onlyCourse'); imshow(imgOut_onlyCoarse);
%     figure, set(gcf,'name','2 Livelli'); imshow(imgOut_2_livelli);
%     figure, set(gcf,'name','1 Livelli'); imshow(imgOut_1_livelli);

end


% ! Risolve problemi convessi!
% ! Non selezionare zone pi vicine di 3 pixel! Ma anche di pi!
% ! Non prendere zone oblique. Cercare di prendere zone rettangolari.



