function img = LinPredDiag(I,mask)
% Metodo il quale, data un'image in ingresso, predice (solo) la zona selezionata
% dalla maschera.
% Predizione del livello COARSES.
% I = input intensity image
% p = predictor order
% img = output image

[Height,Width,Depth] = size(I);
if Depth > 1
    I1 = double(rgb2gray(I));
else
    I1 = double(I);
end

img = I1;
% 
% %Calcolo della autocorrelazione normalizzata
% Cor = autoCorr2DNormalized(I);
% 
% %Calcolo dei coefficienti alfa
% R_u = zeros(3,3);
% R_u(1,1)=Cor(Height,Width);
% R_u(1,2)=Cor(Height-1,Width+1);
% R_u(1,3)=Cor(Height-1,Width);
% R_u(2,1)=Cor(Height+1,Width-1);
% R_u(2,2)=R_u(1,1);
% R_u(2,3)=Cor(Height,Width-1);
% R_u(3,1)=Cor(Height+1,Width);
% R_u(3,2)=Cor(Height,Width+1);
% R_u(3,3)=R_u(1,1);
% 
% r_u=zeros(3,1);
% r_u(1)=Cor(Height,Width+1);
% r_u(2)=Cor(Height+1,Width);
% r_u(3)=Cor(Height+1,Width+1);
% 
% alfa=zeros(3,1);
% alfa=R_u\r_u;

alfa=zeros(1,3);
for i = 1:3
    alfa(i)=1/3;
end

% Inserire il controllo: alfa deve essere di dimensione almeno p

% Implement the Linear Predictor

%pe = zeros(Height,Width);           % array to store prediction errors
%I1 = padarray(I1,[0 1],'symmetric','pre');
for r = 1:Height
    for c = 2:Width
        if(mask(r,c)>=1)% && (c-p>0))
            img(r,c) = alfa(1)*img(r,c-1) + alfa(2)*img(r-1,c) + alfa(3)*img(r-1,c-1);              
        end
    end
end

    
    
    
    
   
    
    
    
    
    
    
    
    
    
    
    
